#include <Servo.h> // Servo motor library
#include <SPI.h> // SPI library
#include <MFRC522.h> // MFRC 522 card reader library
#include <Wire.h> // I2C library

  // E-PAPER DISPLAY

// mapping suggestion for Arduino MEGA
// BUSY -> 7, RST -> 9, DC -> 8, CS-> 53, CLK -> 52, DIN -> 51
// include library, include base class, make path known
#include <GxEPD.h>
#include <GxFont_GFX.h>
// select the display class to use, only one
#include <GxGDEH0213B72/GxGDEH0213B72.h>  // 2.13" b/w new panel
#include <GxIO/GxIO_SPI/GxIO_SPI.h>
// FreeFonts from Adafruit_GFX
#include <Fonts/FreeSansBold12pt7b.h> // TEXT FONT
#include <Fonts/FreeSansBold9pt7b.h> // TEXT FONT
#if defined (ARDUINO_AVR_MEGA2560)
// select one, depending on your CS connection
GxIO_Class io(SPI, /*CS=*/ SS, /*DC=*/ 8, /*RST=*/ 9); // arbitrary selection of 8, 9 selected for default of GxEPD_Class
GxEPD_Class display(io, /*RST=*/ 9, /*BUSY=*/ 7); // default selection of (9), 7
#endif

int ss = 48;//E-PAPER SLAVE SELECT PIN 

  //OLED DISPLAY
  
#include "U8glib.h" // OLED LIBRARY

U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_DEV_0|U8G_I2C_OPT_NO_ACK|U8G_I2C_OPT_FAST);  // Fast I2C / TWI 


void oledMessage(){
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 10, 22, "ALL SYSTEMS");
  u8g.drawStr( 10, 44,"ARE FUNCTIONAL!");
  } while(u8g.nextPage());
    //delay (2000);  
}
// QR CODE FOR MQ5 GAS SENSOR ERROR

const uint8_t gSensor[] PROGMEM = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xf0, 0x00, 0x1c, 0x01, 0xe7, 0x30, 0x00, 0x0f, 0xf0, 0x00, 0x0c, 0x01, 0xe7, 0x30, 0x00, 0x0f, 
  0xf3, 0xff, 0x8f, 0xf0, 0x7f, 0x31, 0xff, 0x8f, 0xf3, 0xff, 0x8f, 0xf0, 0x7f, 0x33, 0xff, 0xcf, 
  0xf3, 0x81, 0x8f, 0x31, 0x9c, 0xf3, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0x31, 0x98, 0xf3, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xb1, 0x1c, 0xf3, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0xc0, 0x07, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xc0, 0x07, 0x33, 0x81, 0xcf, 0xf3, 0xff, 0x8f, 0x31, 0xe7, 0xf3, 0xff, 0xcf, 
  0xf3, 0xff, 0x8f, 0x31, 0xe7, 0xf3, 0xff, 0xcf, 0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 
  0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 0xf8, 0x00, 0x1c, 0x4e, 0x22, 0x38, 0x00, 0x1f, 
  0xff, 0xff, 0xfc, 0x3e, 0x00, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x3e, 0x00, 0x3f, 0xff, 0xff, 
  0xf0, 0xe1, 0x8f, 0x31, 0xe0, 0x33, 0xff, 0xcf, 0xf0, 0xe1, 0x8f, 0x31, 0xe0, 0x33, 0xff, 0xcf, 
  0xfc, 0xf9, 0xf3, 0xc0, 0x00, 0xcc, 0x00, 0x3f, 0xfc, 0xf9, 0xf3, 0xc0, 0x00, 0xcc, 0x00, 0x3f, 
  0xfc, 0x00, 0x00, 0x31, 0xe0, 0x00, 0x07, 0xcf, 0xfc, 0x00, 0x00, 0x31, 0xe0, 0x00, 0x07, 0xcf, 
  0xfc, 0x7f, 0xf8, 0x7e, 0xe2, 0x07, 0xc0, 0x0f, 0xfc, 0xff, 0xfc, 0xfe, 0x67, 0x0f, 0xe0, 0x0f, 
  0xfc, 0xff, 0xfc, 0xfc, 0x66, 0x0f, 0xe0, 0x0f, 0xf3, 0x19, 0x8f, 0x00, 0x78, 0x33, 0xff, 0xcf, 
  0xf3, 0x19, 0x8f, 0x00, 0x78, 0x33, 0xff, 0xcf, 0xf3, 0x06, 0x73, 0x07, 0xe0, 0x3f, 0x9e, 0x3f, 
  0xf3, 0x06, 0x73, 0x0f, 0xe0, 0x3f, 0x9e, 0x3f, 0xf0, 0x19, 0x8f, 0xcf, 0xe0, 0x03, 0x80, 0x0f, 
  0xf0, 0x19, 0x8f, 0xcf, 0xe0, 0x03, 0x80, 0x0f, 0xf1, 0xff, 0xe0, 0x3f, 0xe2, 0x04, 0x40, 0x8f, 
  0xf3, 0xff, 0xf0, 0x3f, 0xe7, 0x0c, 0x61, 0xcf, 0xf3, 0xff, 0xe0, 0x3f, 0xe6, 0x0c, 0x60, 0xcf, 
  0xf3, 0xe6, 0x03, 0xf1, 0x98, 0x00, 0x18, 0x3f, 0xf3, 0xe6, 0x03, 0xf1, 0x98, 0x00, 0x18, 0x3f, 
  0xff, 0xff, 0xfc, 0x0f, 0x98, 0x3f, 0x98, 0x3f, 0xff, 0xff, 0xfc, 0x0f, 0x98, 0x3f, 0x98, 0x3f, 
  0xf0, 0x00, 0x1f, 0xf0, 0x67, 0x33, 0x9f, 0xcf, 0xf0, 0x00, 0x0f, 0xf0, 0x67, 0x33, 0x9f, 0xcf, 
  0xf1, 0xff, 0x8f, 0xf1, 0x98, 0x3f, 0x9f, 0xcf, 0xf3, 0xff, 0x8f, 0xf1, 0x98, 0x3f, 0x9f, 0xcf, 
  0xf3, 0xff, 0x8f, 0xf1, 0x98, 0x3f, 0x1f, 0xdf, 0xf3, 0x01, 0x8c, 0xc0, 0x78, 0x00, 0x1e, 0x3f, 
  0xf3, 0x01, 0x8c, 0xc0, 0x78, 0x00, 0x1e, 0x3f, 0xf3, 0x01, 0x8c, 0x3f, 0x87, 0xc3, 0xfe, 0x0f, 
  0xf3, 0x01, 0x8c, 0x3f, 0x87, 0xc3, 0xfe, 0x0f, 0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x0f, 0x80, 0x0f, 
  0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x0f, 0x80, 0x0f, 0xf3, 0xff, 0x8c, 0x31, 0xe7, 0xfe, 0x18, 0x0f, 
  0xf3, 0xff, 0x8c, 0x31, 0xe7, 0xfc, 0x18, 0x0f, 0xf1, 0xff, 0x8c, 0x31, 0xe7, 0xfe, 0x18, 0x0f, 
  0xf0, 0x00, 0x0c, 0xc0, 0x18, 0x3f, 0xe7, 0xcf, 0xf0, 0x00, 0x1c, 0xc0, 0x1c, 0x3f, 0xe7, 0xcf, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
  };

// QR CODE FOR WATER SENSOR ERROR

const uint8_t wSensor[] PROGMEM = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xf0, 0x00, 0x1c, 0x01, 0xe7, 0x30, 0x00, 0x0f, 0xf0, 0x00, 0x0c, 0x01, 0xe7, 0x30, 0x00, 0x0f, 
  0xf3, 0xff, 0x8f, 0xf0, 0x7f, 0x31, 0xff, 0x8f, 0xf3, 0xff, 0x8f, 0xf0, 0x7f, 0x33, 0xff, 0xcf, 
  0xf3, 0x81, 0x8f, 0x31, 0x9c, 0xf3, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0x31, 0x98, 0xf3, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xb1, 0x1c, 0xf3, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0xc0, 0x07, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0xc0, 0x07, 0x33, 0x81, 0xcf, 0xf3, 0xff, 0x8f, 0x31, 0xe7, 0xf3, 0xff, 0xcf, 
  0xf3, 0xff, 0x8f, 0x31, 0xe7, 0xf3, 0xff, 0xcf, 0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 
  0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 0xf8, 0x00, 0x1c, 0x4e, 0x22, 0x38, 0x00, 0x1f, 
  0xff, 0xff, 0xfc, 0x3e, 0x00, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x3e, 0x00, 0x3f, 0xff, 0xff, 
  0xf0, 0xe1, 0x8f, 0x3f, 0xe0, 0x33, 0xff, 0xcf, 0xf0, 0xe1, 0x9f, 0x3f, 0xe0, 0x33, 0xff, 0xcf, 
  0xf0, 0xfe, 0x7c, 0xc0, 0x00, 0xcc, 0x00, 0x3f, 0xf0, 0xfe, 0x7c, 0xc0, 0x00, 0xcc, 0x00, 0x3f, 
  0xf3, 0x06, 0x1c, 0x30, 0x60, 0x00, 0x07, 0xcf, 0xf3, 0x06, 0x0c, 0x30, 0x60, 0x00, 0x07, 0xcf, 
  0xfc, 0xc0, 0x3f, 0xfc, 0x62, 0x07, 0xc0, 0x0f, 0xfc, 0xe0, 0x7f, 0xfe, 0x67, 0x0f, 0xe0, 0x0f, 
  0xfc, 0x40, 0x3f, 0xfe, 0x66, 0x0f, 0xe0, 0x0f, 0xfc, 0x06, 0x00, 0x01, 0xf8, 0x33, 0xff, 0xcf, 
  0xfc, 0x06, 0x00, 0x01, 0xf8, 0x33, 0xff, 0xcf, 0xf0, 0x18, 0x63, 0xc1, 0xe0, 0x3f, 0x9e, 0x3f, 
  0xf0, 0x18, 0x73, 0xc1, 0xe0, 0x3f, 0x9e, 0x3f, 0xf0, 0x7f, 0x80, 0xc6, 0x60, 0x03, 0x80, 0x0f, 
  0xf0, 0xff, 0x80, 0xce, 0x60, 0x03, 0x80, 0x0f, 0xf1, 0x01, 0xff, 0x3e, 0x62, 0x04, 0x40, 0x8f, 
  0xf3, 0x01, 0xff, 0x3e, 0x67, 0x0c, 0x61, 0xcf, 0xf3, 0x01, 0xff, 0x3e, 0x66, 0x0c, 0x60, 0xcf, 
  0xf3, 0x07, 0x8c, 0xcf, 0x98, 0x00, 0x18, 0x3f, 0xf3, 0x07, 0x9c, 0xcf, 0x98, 0x00, 0x18, 0x3f, 
  0xff, 0xff, 0xfc, 0xce, 0x18, 0x3f, 0x98, 0x3f, 0xff, 0xff, 0xfc, 0xc6, 0x18, 0x3f, 0x98, 0x3f, 
  0xf0, 0x00, 0x1f, 0xc0, 0x67, 0x33, 0x9f, 0xcf, 0xf0, 0x00, 0x0f, 0xc0, 0x67, 0x33, 0x9f, 0xcf, 
  0xf1, 0xff, 0x8f, 0x31, 0x98, 0x3f, 0x9f, 0xcf, 0xf3, 0xff, 0x8f, 0x31, 0x98, 0x3f, 0x9f, 0xcf, 
  0xf3, 0xff, 0x8f, 0x39, 0x98, 0x3f, 0x1f, 0xdf, 0xf3, 0x01, 0x8c, 0x3e, 0x78, 0x00, 0x1e, 0x3f, 
  0xf3, 0x01, 0x8c, 0x3e, 0x78, 0x00, 0x1e, 0x3f, 0xf3, 0x01, 0x8c, 0xcf, 0x87, 0xc3, 0xfe, 0x0f, 
  0xf3, 0x01, 0x8c, 0xcf, 0x87, 0xc3, 0xfe, 0x0f, 0xf3, 0x01, 0x8f, 0x31, 0x9f, 0x0f, 0x80, 0x0f, 
  0xf3, 0x01, 0x8f, 0x31, 0x9f, 0x0f, 0x80, 0x0f, 0xf3, 0xff, 0x8c, 0x01, 0xe7, 0xfe, 0x18, 0x0f, 
  0xf3, 0xff, 0x8c, 0x01, 0xe7, 0xfc, 0x18, 0x0f, 0xf1, 0xff, 0x8c, 0x01, 0xf7, 0xfe, 0x18, 0x0f, 
  0xf0, 0x00, 0x0c, 0xc1, 0xf8, 0x3f, 0xe7, 0xcf, 0xf0, 0x00, 0x1c, 0xc1, 0xfc, 0x3f, 0xe7, 0xcf, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
  };

// QR CODE FOR LIGHT AND MOVEMENT SENSORS ERRORS

const uint8_t lSensor[] PROGMEM = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xf0, 0x00, 0x1f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 
  0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x31, 0xff, 0x8f, 0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x33, 0xff, 0xcf, 
  0xf3, 0x81, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0x01, 0xfc, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc6, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xce, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0xff, 0x8f, 0x0f, 0xe7, 0x33, 0xff, 0xcf, 
  0xf3, 0xff, 0x8f, 0x0f, 0xe7, 0x33, 0xff, 0xcf, 0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 
  0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 0xf8, 0x00, 0x1c, 0xce, 0x72, 0x38, 0x00, 0x1f, 
  0xff, 0xff, 0xff, 0x3e, 0x78, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3e, 0x78, 0x3f, 0xff, 0xff, 
  0xf0, 0xfe, 0x03, 0x0e, 0x00, 0xff, 0x87, 0xff, 0xf0, 0xfe, 0x03, 0x0e, 0x00, 0xff, 0x87, 0xff, 
  0xfc, 0xff, 0xff, 0xcf, 0x80, 0xcc, 0x00, 0x3f, 0xfc, 0xff, 0xff, 0xcf, 0x80, 0xcc, 0x00, 0x3f, 
  0xff, 0x38, 0x1f, 0x3f, 0xf8, 0x30, 0x66, 0x0f, 0xff, 0x18, 0x0f, 0x3f, 0xf8, 0x30, 0x66, 0x0f, 
  0xff, 0xc0, 0x27, 0xc0, 0xf3, 0xff, 0xe7, 0x8f, 0xff, 0xe0, 0x73, 0xc0, 0x67, 0xff, 0xe7, 0xcf, 
  0xff, 0xe0, 0x63, 0xc0, 0x67, 0xff, 0xe7, 0xcf, 0xf3, 0x1f, 0x80, 0x01, 0xf8, 0x33, 0xff, 0xcf, 
  0xf3, 0x1f, 0x80, 0x01, 0xf8, 0x33, 0xff, 0xcf, 0xf3, 0x07, 0xe3, 0xc0, 0x18, 0x3c, 0x7e, 0x3f, 
  0xf3, 0x07, 0xf3, 0xc0, 0x18, 0x3c, 0x7e, 0x3f, 0xf3, 0xc1, 0x8f, 0xc6, 0x00, 0xc0, 0x06, 0x0f, 
  0xf3, 0xe1, 0x8f, 0xce, 0x00, 0xc0, 0x06, 0x0f, 0xf3, 0xfe, 0x7f, 0xb0, 0x23, 0x04, 0x41, 0x8f, 
  0xf3, 0xfe, 0x7f, 0x30, 0x67, 0x0c, 0x61, 0xcf, 0xf3, 0xfe, 0x3f, 0x30, 0x62, 0x0c, 0x61, 0xcf, 
  0xf3, 0x1e, 0x00, 0xf1, 0x80, 0x00, 0x19, 0xff, 0xf3, 0x3e, 0x00, 0xf1, 0x80, 0x00, 0x19, 0xff, 
  0xff, 0xff, 0xfc, 0xcf, 0x98, 0x3f, 0x9f, 0xff, 0xff, 0xff, 0xfc, 0xc7, 0x98, 0x3f, 0x9f, 0xff, 
  0xf0, 0x00, 0x1c, 0x01, 0xe7, 0x33, 0x9f, 0xcf, 0xf0, 0x00, 0x0c, 0x01, 0xe7, 0x33, 0x9f, 0xcf, 
  0xf1, 0xff, 0x8c, 0xc0, 0x60, 0x3f, 0x9f, 0xcf, 0xf3, 0xff, 0x8c, 0xc0, 0x60, 0x3f, 0x9f, 0xcf, 
  0xf3, 0xff, 0x8c, 0xc0, 0x60, 0x3f, 0x1f, 0xdf, 0xf3, 0x01, 0x8f, 0x00, 0x18, 0x00, 0x18, 0x3f, 
  0xf3, 0x01, 0x8f, 0x00, 0x18, 0x00, 0x18, 0x3f, 0xf3, 0x01, 0x8f, 0xc7, 0x87, 0xc3, 0xfe, 0x0f, 
  0xf3, 0x01, 0x8f, 0xcf, 0x87, 0xc3, 0xfe, 0x0f, 0xf3, 0x01, 0x8f, 0xcf, 0x87, 0x3f, 0xe1, 0x8f, 
  0xf3, 0x01, 0x8f, 0xcf, 0x87, 0x3f, 0xe1, 0xcf, 0xf3, 0xff, 0x8c, 0x00, 0x67, 0x0e, 0x1f, 0xcf, 
  0xf3, 0xff, 0x8c, 0x00, 0x67, 0x0c, 0x1f, 0xcf, 0xf1, 0xff, 0x8c, 0x00, 0x76, 0x0e, 0x1f, 0xcf, 
  0xf0, 0x00, 0x0c, 0x3e, 0x78, 0x3f, 0xe7, 0xcf, 0xf0, 0x00, 0x1c, 0x3e, 0x7c, 0x3f, 0xe7, 0xcf, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
  };

// QR CODE FOR TEMPERATURE SENSOR ERROR

const uint8_t tSensor[] PROGMEM = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xf0, 0x00, 0x1f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 
  0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x31, 0xff, 0x8f, 0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x33, 0xff, 0xcf, 
  0xf3, 0x81, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0x01, 0xfc, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc6, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xce, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0xff, 0x8f, 0x0e, 0x67, 0x33, 0xff, 0xcf, 
  0xf3, 0xff, 0x8f, 0x0e, 0x67, 0x33, 0xff, 0xcf, 0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 
  0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 0xf8, 0x00, 0x1c, 0xce, 0xf2, 0x38, 0x00, 0x1f, 
  0xff, 0xff, 0xff, 0x3f, 0xf8, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3f, 0xf8, 0x3f, 0xff, 0xff, 
  0xf0, 0xfe, 0x03, 0x0e, 0x00, 0xff, 0x87, 0xff, 0xf0, 0xfe, 0x03, 0x06, 0x00, 0xff, 0x87, 0xff, 
  0xf0, 0x01, 0xe3, 0xc1, 0x80, 0xcc, 0x00, 0x3f, 0xf0, 0x01, 0xf3, 0xc1, 0x80, 0xcc, 0x00, 0x3f, 
  0xf0, 0x46, 0x03, 0x3e, 0x78, 0x30, 0x66, 0x0f, 0xf0, 0xe6, 0x03, 0x3e, 0x78, 0x30, 0x66, 0x0f, 
  0xff, 0xe7, 0xe0, 0xce, 0x73, 0xff, 0xe7, 0x8f, 0xff, 0xe7, 0xf0, 0xce, 0x67, 0xff, 0xe7, 0xcf, 
  0xff, 0xe7, 0xe0, 0xce, 0x67, 0xff, 0xe7, 0xcf, 0xff, 0x19, 0x83, 0x0e, 0x78, 0x33, 0xff, 0xcf, 
  0xff, 0x19, 0x83, 0x06, 0x78, 0x33, 0xff, 0xcf, 0xf3, 0x1f, 0xff, 0x01, 0x98, 0x3c, 0x7e, 0x3f, 
  0xf3, 0x1f, 0xff, 0x01, 0x98, 0x3c, 0x7e, 0x3f, 0xf3, 0xfe, 0x1c, 0xff, 0x80, 0xc0, 0x06, 0x0f, 
  0xf3, 0xfe, 0x0c, 0xff, 0x80, 0xc0, 0x06, 0x0f, 0xf3, 0x81, 0xff, 0xe0, 0x63, 0x04, 0x41, 0x8f, 
  0xf3, 0x01, 0xff, 0xc0, 0x67, 0x0c, 0x61, 0xcf, 0xf3, 0x01, 0xff, 0xc0, 0x62, 0x0c, 0x61, 0xcf, 
  0xf3, 0x1e, 0x0f, 0x0f, 0x80, 0x00, 0x19, 0xff, 0xf3, 0x3e, 0x1f, 0x0f, 0x80, 0x00, 0x19, 0xff, 
  0xff, 0xff, 0xfc, 0xcf, 0x98, 0x3f, 0x9f, 0xff, 0xff, 0xff, 0xfc, 0xc7, 0x98, 0x3f, 0x9f, 0xff, 
  0xf0, 0x00, 0x1c, 0x00, 0x67, 0x33, 0x9f, 0xcf, 0xf0, 0x00, 0x0c, 0x00, 0x67, 0x33, 0x9f, 0xcf, 
  0xf1, 0xff, 0x8c, 0x1c, 0x60, 0x3f, 0x9f, 0xcf, 0xf3, 0xff, 0x8c, 0x3e, 0x60, 0x3f, 0x9f, 0xcf, 
  0xf3, 0xff, 0x8c, 0x1e, 0x60, 0x3f, 0x1f, 0xdf, 0xf3, 0x01, 0x8f, 0x0f, 0x98, 0x00, 0x18, 0x3f, 
  0xf3, 0x01, 0x8f, 0x0f, 0x98, 0x00, 0x18, 0x3f, 0xf3, 0x01, 0x8f, 0xcf, 0x87, 0xc3, 0xfe, 0x0f, 
  0xf3, 0x01, 0x8f, 0xcf, 0x87, 0xc3, 0xfe, 0x0f, 0xf3, 0x01, 0x8f, 0xce, 0x07, 0x3f, 0xe1, 0x8f, 
  0xf3, 0x01, 0x8f, 0xce, 0x07, 0x3f, 0xe1, 0xcf, 0xf3, 0xff, 0x8c, 0x00, 0x67, 0x0e, 0x1f, 0xcf, 
  0xf3, 0xff, 0x8c, 0x00, 0x67, 0x0c, 0x1f, 0xcf, 0xf1, 0xff, 0x8c, 0x00, 0x76, 0x0e, 0x1f, 0xcf, 
  0xf0, 0x00, 0x0c, 0xf0, 0x78, 0x3f, 0xe7, 0xcf, 0xf0, 0x00, 0x1c, 0xf8, 0x7c, 0x3f, 0xe7, 0xcf, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
  };

// QR CODE FOR FLAME SENSOR ERROR

const uint8_t fSensor[] PROGMEM = {
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xf0, 0x00, 0x1f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0x01, 0xe7, 0x30, 0x00, 0x0f, 
  0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x31, 0xff, 0x8f, 0xf3, 0xff, 0x8f, 0xf0, 0x07, 0x33, 0xff, 0xcf, 
  0xf3, 0x81, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8f, 0x01, 0xf8, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8f, 0x01, 0xfc, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xc0, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0x01, 0x8c, 0xc6, 0x1f, 0x33, 0x81, 0xcf, 
  0xf3, 0x01, 0x8c, 0xce, 0x1f, 0x33, 0x81, 0xcf, 0xf3, 0xff, 0x8f, 0x0f, 0xe7, 0x33, 0xff, 0xcf, 
  0xf3, 0xff, 0x8f, 0x0f, 0xe7, 0x33, 0xff, 0xcf, 0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 
  0xf0, 0x00, 0x0c, 0xce, 0x67, 0x30, 0x00, 0x0f, 0xf8, 0x00, 0x1c, 0xc6, 0xf2, 0x38, 0x00, 0x1f, 
  0xff, 0xff, 0xff, 0x31, 0xf8, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x31, 0xf8, 0x3f, 0xff, 0xff, 
  0xf0, 0xfe, 0x03, 0x0f, 0x80, 0xff, 0x87, 0xff, 0xf0, 0xfe, 0x03, 0x0f, 0x80, 0xff, 0x87, 0xff, 
  0xfc, 0x07, 0xff, 0xcf, 0x80, 0xcc, 0x00, 0x3f, 0xfc, 0x07, 0xff, 0xcf, 0x80, 0xcc, 0x00, 0x3f, 
  0xf3, 0x1e, 0x00, 0x3f, 0xf8, 0x30, 0x66, 0x0f, 0xf3, 0x1e, 0x00, 0x3f, 0xf8, 0x30, 0x66, 0x0f, 
  0xfc, 0x01, 0xff, 0xce, 0xf3, 0xff, 0xe7, 0x8f, 0xfc, 0x01, 0xff, 0xce, 0x67, 0xff, 0xe7, 0xcf, 
  0xfc, 0x01, 0xff, 0xce, 0x67, 0xff, 0xe7, 0xcf, 0xfc, 0x06, 0x0f, 0x0f, 0xf8, 0x33, 0xff, 0xcf, 
  0xfc, 0x06, 0x0f, 0x07, 0xf8, 0x33, 0xff, 0xcf, 0xf0, 0x06, 0x73, 0x00, 0x18, 0x3c, 0x7e, 0x3f, 
  0xf0, 0x06, 0x73, 0x00, 0x18, 0x3c, 0x7e, 0x3f, 0xf3, 0xc1, 0x8f, 0x3f, 0x80, 0xc0, 0x06, 0x0f, 
  0xf3, 0xe1, 0x8f, 0x3f, 0x80, 0xc0, 0x06, 0x0f, 0xf3, 0x9e, 0x7c, 0xcf, 0xe3, 0x04, 0x41, 0x8f, 
  0xf3, 0x1e, 0x7c, 0xcf, 0xe7, 0x0c, 0x61, 0xcf, 0xf3, 0x1e, 0x7c, 0xc7, 0xe2, 0x0c, 0x61, 0xcf, 
  0xf3, 0x01, 0x83, 0xc0, 0x00, 0x00, 0x19, 0xff, 0xf3, 0x01, 0x83, 0xc0, 0x00, 0x00, 0x19, 0xff, 
  0xff, 0xff, 0xfc, 0x31, 0x98, 0x3f, 0x9f, 0xff, 0xff, 0xff, 0xfc, 0x31, 0x98, 0x3f, 0x9f, 0xff, 
  0xf0, 0x00, 0x1c, 0x01, 0xe7, 0x33, 0x9f, 0xcf, 0xf0, 0x00, 0x0c, 0x01, 0xe7, 0x33, 0x9f, 0xcf, 
  0xf1, 0xff, 0x8c, 0xf0, 0x60, 0x3f, 0x9f, 0xcf, 0xf3, 0xff, 0x8c, 0xf0, 0x60, 0x3f, 0x9f, 0xcf, 
  0xf3, 0xff, 0x8c, 0xf0, 0x60, 0x3f, 0x1f, 0xdf, 0xf3, 0x01, 0x8f, 0x0e, 0x18, 0x00, 0x18, 0x3f, 
  0xf3, 0x01, 0x8f, 0x06, 0x18, 0x00, 0x18, 0x3f, 0xf3, 0x01, 0x8f, 0xc1, 0x87, 0xc3, 0xfe, 0x0f, 
  0xf3, 0x01, 0x8f, 0xc1, 0x87, 0xc3, 0xfe, 0x0f, 0xf3, 0x01, 0x8f, 0x3f, 0x87, 0x3f, 0xe1, 0x8f, 
  0xf3, 0x01, 0x8f, 0x3f, 0x87, 0x3f, 0xe1, 0xcf, 0xf3, 0xff, 0x8c, 0x03, 0xe7, 0x0e, 0x1f, 0xcf, 
  0xf3, 0xff, 0x8c, 0x01, 0xe7, 0x0c, 0x1f, 0xcf, 0xf1, 0xff, 0x8c, 0x01, 0xe2, 0x0e, 0x1f, 0xcf, 
  0xf0, 0x00, 0x0c, 0xf1, 0xe0, 0x3f, 0xe7, 0xcf, 0xf0, 0x00, 0x1c, 0xf9, 0xe0, 0x3f, 0xe7, 0xcf, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
  };
  
  // RFID CARD READER

#define SS_PIN 53 // Slave Select pin for MFRC522
#define RST_PIN 5 // Reset pin for MFRC522
MFRC522 mfrc522(SS_PIN, RST_PIN); // Initializing MFRC522 pins

  // SERVO MOTOR MG 90 S

Servo servo1; // Servo motor  
int pos1 = 0; // Variable to store the position of the servo motor

  // DHT 22 SENSOR and the FAN

#include "DHT.h"  // DHT22 sensor library
#define DHTpin 6 // Digital pin connection to Arduino for the DHT22 sensor
#define fan 10   // Fan pin connection
#define DHTTYPE DHT22   // Defining sensor type as DHT 22  
DHT dht(DHTpin, DHTTYPE); // Initializing DHT sensor
int tmax = 31; // The temperature in degrees celsius from which to turn the fan on 

  // MOVEMENT SENSOR AND LIGHT SENSOR

#define pirSensor 26 // Digital pin connection to Arduino for the PIR sensor 
#define ledPin 11 // Select the pin for the LED 
#define lightSensor  A0 // Analogic pin connection to Arduino for the light sensor 
int pirVal = 0; // Variable to store the value coming from the PIR sensor
 
  // WATER SENSOR
  
#define waterSensor  A3 // Analogic pin connection to Arduino for the water sensor   
#define blueLed 30 // Blue led pin connection
int wsensVal = 0; // Variable to store the value coming from the sensor

  // GAS SENSOR MQ5

#define gasSensor A5 // Analogic pin connection to Arduino for the gas sensor 
#define yelowLed 31 // Yelow led pin connection
int gsensVal = 0; // Variable to store the value coming from the sensor

  // BELL

#define bell 22 // Bell pin connection

  // ERROR LED

#define greenLed 33 // Error led pin connection

  // FLAME SENSOR 

#define flameSensor A7 // Analogic pin connection to Arduino for the flame sensor 
#define redLed 32 // Red led pin connection
int fireVal = 0 ; // Variable to store the value coming from the sensor

void setup() 
{
  Serial.begin(115200);   // Starting serial communication

  // E-paper initialization
  
  Serial.println("setup"); // Print this message on the serial monitor
  display.init(115200); // E-paper initialization
  Serial.println("setup done"); // Print this message on the serial monitor
  pinMode(ss,OUTPUT);//E-paper slave select output
 
  // Bell initialization
  
   pinMode(bell,OUTPUT); // Bell pin is configured as output signal

  // Error led initialization
  
   pinMode(greenLed,OUTPUT); // Error led pin is configured as output signal
   
  // Gas sensor initialization  
   
    pinMode(gasSensor,INPUT); // Gas sensor pin is configured as input signal
    pinMode(yelowLed,OUTPUT); // Yelow led pin is configured as output signal
    Serial.println("GAS SENSOR ACTIVE"); // Print this message on the serial monitor
    delay(500); // Introducing a 500 ms delay until the next message appears
    
  // Water sensor initialization 
  
  pinMode(waterSensor,INPUT); // Water sensor pin is configured as input signal
  pinMode(blueLed, OUTPUT); // Blue led pin is configured as output signal
  
  // Light sensor, movement sensor and led initialization 

  pinMode(lightSensor,INPUT); // Light sensor pin is configured as input signal
  pinMode(pirSensor,INPUT); // Pir sensor pin is configured as input signal
  pinMode(ledPin,OUTPUT); // Led pin is configured as output signal
  
  // DHT 22 and Fan initialization
  
  Serial.println("Testing DHT sensor!"); // Print this message on the serial monitor
  pinMode(fan, OUTPUT); // Fan pin is configured as output signal
  pinMode(DHTpin, INPUT); // DHT 22 sensor pin is configured as input signal
  dht.begin(); // Turning on DHT 22 sensor

  // Flame sensor initialization 

   pinMode(flameSensor,INPUT); // Flame sensor pin is configured as input signal
   pinMode(redLed,OUTPUT); // Red led pin is configured as output signal
 
  // MFRC522 and SERVO MOTOR initialization
  
  SPI.begin();      // Serial Peripheral Interface initialization
  mfrc522.PCD_Init();   // MFRC522 initialization
  //Serial.println("Place your card on the reader...");
  //Serial.println();
  servo1.attach(3); // Servo motor pin connection
  servo1.write(85); // Servo motor starting position

  
}

void loop() 
{

    // E-PAPER STANDARD MESSAGE

    digitalWrite(ss,LOW); // Turn Slave Select pin on 
    showPartialUpdatewT(); // Partial update - Welcome Text
    digitalWrite(ss,HIGH); // Turn Slave Select pin on 
 
  
   // MQ5 GAS SENSOR AND THE BELL
   
    gsensVal = analogRead(gasSensor); // Reading the data received from the gas sensor and store it in the "gsensVal" variable
    //Serial.print("Gas sensor value: "); // Print this text on the serial monitor
    //Serial.println(gsensVal); // Print the value from the sensor on the serial monitor */
   
   // Function to check for gas sensor errors
   
    if(gsensVal >= 710 || gsensVal <= 180){  // Set warning thresholds for gas sensor malfunction
    
    digitalWrite(greenLed, !digitalRead(greenLed)); // Blink the green led 
    delay(250); // 250 ms delay between the on and off state of the green led

  // OLED MESSAGE WARNING

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 20, 22, "GAS SENSOR");
  u8g.drawStr( 30, 44,"FAULTY!");
  } while(u8g.nextPage());
    delay (1000);
      
  // QR CODE LABEL 

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 0, 20, "SCAN");
  u8g.drawStr( 0, 40, "THIS");
  u8g.drawStr( 0, 60, "QR CODE");
  u8g.drawBitmapP( 60, 0, 8, 64, gSensor);
    } while(u8g.nextPage());
    delay(2000);
  
    /*Serial.println("GAS SENSOR FAULTY!"); // Message shown if the sensor is faulty
    delay(500); // 500 ms delay
    Serial.println(gsensVal); // Print the value from the sensor on the serial monitor*/
    }else {
      oledMessage();
      digitalWrite(greenLed,LOW);
    }
    
   // Set warning thresholds for atmospheric gas detection 

  if (gsensVal >= 500 && gsensVal <= 700) // If the value is in this limits the sensor will show that a gas leak has been detected
                                          // and the alarm will start 
  {
    tone(bell,1100,400); // We set the frequency of the ringtone in Hertz and its duration
    delay(500); // 500 ms pause of the bell is inserted
    digitalWrite(yelowLed, !digitalRead(yelowLed)); // Blink the green led 
    delay(500); // 500 ms delay between the on and off state of the green led
    
    
    // OLED MESSAGE GAS LEAK WARNING

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 30, 32, "GAS LEAK!");
  } while(u8g.nextPage());
    delay (2000);
      
    /* 
     Serial.print("Gas sensor value: "); // Print this text on the serial monitor
     Serial.print(gsensVal); // Print the value from the sensor on the serial monitor
     Serial.println("\t Gas leakage!!!"); // Print this message on the serial monitor,when a gas leak occurs
     delay(1000); // Introducing one second delay between messages
     */  
  }
  else if (gsensVal >= 190 && gsensVal <= 500 ) // When the value read by the sensor is below 500, this means that there is no gas leak
  { 
     digitalWrite(bell,255); // The bell is turned off
     digitalWrite(yelowLed,LOW); // Yelow led is turned off
     }
  
  // WATER SENSOR AND THE BELL

   int wsensVal = analogRead(waterSensor); // Reading the data received from the gas sensor and store it in the "wsensVal" variable
  /* Serial.print("Water sensor value: "); // Print this text on the serial monitor
   Serial.println(wsensVal); // Print the value from the sensor on the serial monitor */
   //delay(250); // Introducing 250 ms delay between messages
    
  // Function to check for sensor errors
  
    if(wsensVal < 500 || wsensVal >= 1010 ){  // Set warning thresholds for water sensor malfunction
    
    digitalWrite(greenLed, !digitalRead(greenLed)); // Blink the green led 
    delay(250); // 250 ms delay between the on and off state of the green led
    
 // OLED MESSAGE WARNING

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 10, 22,"WATER SENSOR");
  u8g.drawStr( 30, 44,"FAULTY!");
  } while(u8g.nextPage());
    delay (1000);
      
  // QR CODE LABEL 

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 0, 20, "SCAN");
  u8g.drawStr( 0, 40, "THIS");
  u8g.drawStr( 0, 60, "QR CODE");
  u8g.drawBitmapP( 60, 0, 8, 64, wSensor);
    } while(u8g.nextPage());
    delay(2000);
    }
    else{
      oledMessage();
      digitalWrite(greenLed,LOW);
      }
      
  // Set warning thresholds for water detection
  
  if(wsensVal >= 500 && wsensVal < 900){ // If the value is <900 the sensor will show that there is a water leak 
                      // and the alarm will be turned on 
    
     tone(bell,900,700); // We set the frequency of the ringtone in Hertz and its duration 
     digitalWrite(blueLed,HIGH); //Blue led is turned on
     delay(900); // 900 ms pause of the bell is inserted
     
     // OLED MESSAGE WATER LEAK WARNING

  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 20, 32,"WATER LEAK!");
  } while(u8g.nextPage());
    delay (2000);
    // Serial.print("Water leak! \n"); // Print this text on the serial monitor if a water leak is detected  
    // delay(1000); // One second delay is inserted
  }
  else if(wsensVal > 900 || wsensVal <= 1010 ){ // If the value is > 900 the sensor will show that there is no water leak 
                                                // and the alarm will be turned off    
    digitalWrite(bell,255); // The bell will be turned off 
    digitalWrite(blueLed,LOW); // Blue led will be turned off
   // Serial.print("Water sensor is functional.\n"); // Print this text on the serial monitor if no water leak is detected  
  }
  
   // LIGHT SENSOR AND MOVEMENT SENSOR 
  
   pirVal = digitalRead(pirSensor); // Variable to store the value coming from the PIR sensor 
   int lightSensor  = analogRead(A0); // Variable to store the value coming from the light sensor 
   /*Serial.print("\nPIR value : "); // Print this text on the serial monitor 
   Serial.println(pirVal); // Print the value from the PIR sensor on the serial monitor
   Serial.print("\nLight sensor value: ");// Print this text on the serial monitor 
   Serial.print(lightSensor); // Print the value from the light sensor on the serial monitor  */
  
  // Function to check for sensor errors
  
  // Set warning thresholds for light sensor and movement sensor malfunction

    if(lightSensor < 800){  

    digitalWrite(greenLed, !digitalRead(greenLed)); // Blink the green led 
    delay(250); // 250 ms delay between the on and off state of the green led
    
 // OLED MESSAGE WARNING
 
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);  
  u8g.drawStr( 10, 22,"LIGHT SENSORS");
  u8g.drawStr( 35, 44,"FAULTY!");
  } while(u8g.nextPage());
    delay (1000);
      
  // QR CODE LABEL
   
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 0, 20, "SCAN");
  u8g.drawStr( 0, 40, "THIS");
  u8g.drawStr( 0, 60, "QR CODE");
  u8g.drawBitmapP( 60, 0, 8, 64, lSensor);
    } while(u8g.nextPage());
    delay(2000);
    }else {
      oledMessage();
      digitalWrite(greenLed,LOW);
      }
    
  if(pirVal == 1 && lightSensor > 930 ) // Set the thresholds of the sensors to turn on the light
  {
  //Serial.println("Lights on."); // Print this message on the serial monitor
  digitalWrite(11,HIGH); // Turn on the light
  delay(1000); // Keep the light on for one second
  //delay(500); // 500 ms delay between the messages displayed on the serial monitor
 }
 else{
 // Serial.println("Lights off."); // Print this message on the serial monitor
  digitalWrite(11,LOW); // Turn off the light if no movement is detected 
  //delay(500); // 500 ms delay between the messages displayed on the serial monitor 
 }

  // DHT 22 SENSOR and the FAN
  
  // delay(2000); // Two seconds delay between measuring temperatures
  
  float t = dht.readTemperature(); // The temperature reads in degrees celsius 
  float h = dht.readHumidity(); // Humidity readings in percentages
  /*
  // Calculation of human body perceived temperature using the following syntax 
  float hic = dht.computeHeatIndex(t, h,false);  
  Serial.print("\nTemperature: "); // Print this message on the serial monitor
  Serial.print(t); // Print the value stored in variable "t" on the serial monitor
  Serial.print("*C\t"); // Print this message on the serial monitor
  
  Serial.print("\nHumidity: "); // Print this message on the serial monitor
  Serial.print(h); // Print the value stored in variable "h" on the serial monitor
  Serial.print("%\t"); // Print this message on the serial monitor

  Serial.print("Perceived temperature: "); // Print this message on the serial monitor
  Serial.print(hic); // Print the value stored in variable "hic" on the serial monitor
  Serial.print("*C\n"); // Print this message on the serial monitor  */
 
  // Function to check for sensor errors

    if(isnan(t) || isnan(h)){  // Verify that the value sent to Arduino by the sensor is a number
    digitalWrite(greenLed, !digitalRead(greenLed)); // Blink the green led 
    delay(250); // 250 ms delay between the on and off state of the green led
    
  // OLED MESSAGE WARNING
  
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 20, 22,"TEMPERATURE");
  u8g.drawStr( 10, 44,"SENSOR FAULTY!");
  } while(u8g.nextPage());
    delay (1000);
      
  // QR CODE LABEL 
  
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 0, 20, "SCAN");
  u8g.drawStr( 0, 40, "THIS");
  u8g.drawStr( 0, 60, "QR CODE");
  u8g.drawBitmapP( 60, 0, 8, 64, tSensor);
    } while(u8g.nextPage());
    delay(2000);
    }else{
      oledMessage();
      digitalWrite(greenLed, LOW);
      }
      
  // Turn the fan on when the maximum temperature is exceeded
 
   if( t > tmax  ){
    digitalWrite(fan,HIGH); // Turn the fan on
   }else{
    digitalWrite(fan,LOW); // Turn the fan off
   }
 
  // FLAME SENSOR 
 
   fireVal = analogRead(flameSensor); // Reading the data received from the flame sensor and store it in the "fireVal" variable 
  /* Serial.print("Fire val: ");
   Serial.println(fireVal); // Print the value from the sensor on the serial monitor 
   delay(250); */

   // Function to check for flame sensor errors
   
    if(fireVal <= 800||fireVal >= 1015){  // Set warning thresholds for flame sensor malfunction

    digitalWrite(greenLed, !digitalRead(greenLed)); // Blink the green led 
    delay(250); // 250 ms delay between the on and off state of the green led
    
 // OLED MESSAGE WARNING
 
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 10, 22,"FLAME SENSOR");
  u8g.drawStr( 30, 44,"FAULTY!");
  } while(u8g.nextPage());
    delay (1000);
      
  // QR CODE LABEL 
  
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 0, 20, "SCAN");
  u8g.drawStr( 0, 40, "THIS");
  u8g.drawStr( 0, 60, "QR CODE");
  u8g.drawBitmapP( 60, 0, 8, 64, fSensor);
    } while(u8g.nextPage());
    delay(2000);
   
 /* Serial.println("FLAME SENSOR FAULTY!"); // Message shown if the sensor is faulty
    delay(500); // 500 ms delay
    Serial.println(fireVal); // Print the value from the sensor on the serial monitor */
    } else {
      oledMessage();
      digitalWrite(greenLed, LOW);
      }
    
   // Set warning thresholds for flame detection 
  
  if( fireVal >= 810 && fireVal < 950 ) // If the value is < 810 the sensor will show that a fire has been detected
                      // and the alarm will start 
  {
    tone(bell,750,500); // We set the frequency of the ringtone in Hertz and its duration
    digitalWrite(redLed,HIGH); // Red led is turned on
    delay(1000); // One second pause of the bell is inserted
    
    // OLED MESSAGE FIRE WARNING
 
  u8g.firstPage();
  do{
  u8g.setFont(u8g_font_unifont);
  u8g.drawStr( 45, 32,"FIRE!");
  } while(u8g.nextPage());
    delay (2000);
    //Serial.println("Fire! Fire!"); // Print this message on the serial monitor if a fire is detected     
  }
  else{
    digitalWrite(bell,255); // The bell is turned off
    digitalWrite(redLed,LOW); // Red led is turned off
   //Serial.println("Flame sensor is functional."); // Print this message on the serial monitor if no fire is detected  
  }

  // RFID 

  // Searching for new access cards

  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return;
  }

  //Show UID on serial monitor

  Serial.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  
  // Print this message on the serial monitor depending on the card that is read  
  
  //Serial.println();
  //Serial.print("Message: ");
   content.toUpperCase();
  // Setting up the cards that are going to have access
  
  // E-PAPER, RFID AND SERVO MOTOR 
  
 if (content.substring(1) == "80 89 0E 19" || content.substring(1) == "3D 3B 6B 62") 
  { 
    
    digitalWrite(ss,LOW); // Turn Slave Select pin off
    showPartialUpdateaG(); // Partial update - Access Granted
    //Serial.println("Access granted."); // Print this message on the serial monitor
    //Serial.println("aG"); // Print this message on the serial monitor
    for(pos1=85;pos1>1;pos1-=1){ // Open the door from position 85 to 0
    servo1.write(pos1);
    delay(25);  // Delay to slowly open the door  
    }
    delay(2000);
    for(pos1=0;pos1<86;pos1 +=1){ // Close the door from position 0 to 85
    servo1.write(pos1);
    delay(25);  // Delay to slowly close the door  
  }
    showPartialUpdatewT(); // Partial update - Welcome Text
    digitalWrite(ss,HIGH); // Turn Slave Select pin on 
  }
 else {
    digitalWrite(ss,LOW); // Turn Slave Select pin off
    showPartialUpdateaD(); // Partial update - Access Denied
    Serial.println("aD"); // Print this message on the serial monitor
    delay(1000); // Insert one second delay
    showPartialUpdatewT(); // Partial update - Welcome Text
    digitalWrite(ss,HIGH); // Turn Slave Select pin on
    delay(1500); // Introducing 1,5 seconds delay to show the message on the e-paper
  //reset the background
  //display.setRotation(0);
  //display.powerDown();
    
    //lcd.clear(); // Clear the screen  
    // Serial.println(" Access denied!");
    //Serial.println(); 
     }  
}

// ** E-PAPER MESSAGES **

void wT(uint32_t v){//WELCOME TEXT 
  display.setCursor(55,30);//DISTANCE FROM LEFT, DISTANCE FROM TOP
  display.setTextColor(GxEPD_BLACK);
  display.setFont(&FreeSansBold12pt7b);
  display.print("WELCOME"); // Print this message on the e-paper screen
  display.setFont(&FreeSansBold9pt7b);
  display.setCursor(20,65);//DISTANCE FROM LEFT, DISTANCE FROM TOP
  display.print("PLEASE"); // Print this message on the e-paper screen
  display.setCursor(100,65);//DISTANCE FROM LEFT, DISTANCE FROM TOP
  display.print("APPROACH A"); // Print this message on the e-paper screen
  display.setCursor(20,95);//DISTANCE FROM LEFT, DISTANCE FROM TOP
  display.print("CARD TO THE READER"); // Print this message on the e-paper screen
  display.drawRect(10,5,229,100, GxEPD_BLACK);//DISTANCE FROM LEFT, DISTANCE FROM TOP,LENGTH,WIDTH//
 
  uint16_t box_x = 0;//BOX X axis distance from edge
  uint16_t box_y = 0;//BOX y axis distance from the edge
  uint16_t box_w = 230;// BOX WIDTH
  uint16_t box_h = 5;// BOX HEIGHT
  //rectangle distances
  display.fillRect(box_x, box_y, box_w, box_h, GxEPD_WHITE);  
}
  void showaG(const uint32_t v) //TEXT: ACCESS GRANTED
{//text distances
  uint16_t box_x = 10;//BOX X axis distance from edge
  uint16_t box_y = 10;//BOX y axis distance from the edge
  uint16_t box_w = 230;// BOX WIDTH
  uint16_t box_h = 50;// BOX HEIGHT
  uint16_t cursor_y = box_y + box_h;
  //rectangle distances
  display.fillRect(box_x, box_y, box_w, box_h, GxEPD_WHITE);
  display.drawRect(5,30,235,40, GxEPD_BLACK);
  display.setCursor(box_x, cursor_y);
  display.print("ACCESS GRANTED"); // Print this message on the e-paper screen
}
void showaD(const uint32_t v) //TEXT: ACCESS DENIED
{//text distances
  uint16_t box_x = 25;//BOX X axis distance from edge
  uint16_t box_y = 10;//BOX y axis distance from the edge
  uint16_t box_w = 230;// BOX WIDTH
  uint16_t box_h = 50;// BOX HEIGHT
  uint16_t cursor_y = box_y + box_h;
  //rectangle distances
  display.fillRect(box_x, box_y, box_w, box_h, GxEPD_WHITE);
  display.drawRect(18,30, 210,40, GxEPD_BLACK);
  display.setCursor(box_x, cursor_y);
  display.print("ACCESS DENIED"); // Print this message on the e-paper screen
}
void showPartialUpdateaG() // UPDATE IMAGE - PARTIAL UPDATE
{
  uint16_t box_x = 0;//BOX X axis distance from edge
  uint16_t box_y = 5;//BOX y axis distance from the edge
  uint16_t box_w = 240;// BOX WIDTH
  uint16_t box_h = 120;// BOX HEIGHT
  uint16_t cursor_y = box_y + box_h ;
  display.setFont(&FreeSansBold12pt7b);
  display.setTextColor(GxEPD_BLACK);
  display.setRotation(3);
  display.drawPagedToWindow(showaG, box_x, box_y, box_w, box_h);  
    }  
 void showPartialUpdateaD() // UPDATE IMAGE - PARTIAL UPDATE
{
  uint16_t box_x = 0;//BOX X axis distance from edge
  uint16_t box_y = 5;//BOX y axis distance from the edge
  uint16_t box_w = 240;// BOX WIDTH
  uint16_t box_h = 120;// BOX HEIGHT
  uint16_t cursor_y = box_y + box_h ;
  display.setFont(&FreeSansBold12pt7b);
  display.setTextColor(GxEPD_BLACK);
  display.setRotation(3);
  display.drawPagedToWindow(showaD, box_x, box_y, box_w, box_h);
  display.drawRect(showaD, box_x, box_y, box_w, box_h);
  delay(1000);
  display.drawPagedToWindow(wT, box_x, box_y, box_w, box_h); // WELCOME TEXT
/* reset the background
  display.setRotation(0);
  display.powerDown();
  */  
}
void showPartialUpdatewT() // UPDATE IMAGE - PARTIAL UPDATE
{
  uint16_t box_x = 0;//BOX X axis distance from edge
  uint16_t box_y = 5;//BOX y axis distance from the edge
  uint16_t box_w = 240;// BOX WIDTH
  uint16_t box_h = 120;// BOX HEIGHT
  uint16_t cursor_y = box_y + box_h ;
  display.setFont(&FreeSansBold12pt7b);
  display.setTextColor(GxEPD_BLACK);
  display.setRotation(3);  
  display.drawPagedToWindow(wT, box_x, box_y, box_w, box_h);
  }

  




