//Board ESP 32 Dev Module

#include <Servo.h>
#define BLYNK_PRINT Serial
#include <WiFi.h>
#include <SPI.h>
#include <WiFiClient.h>
#include <BlynkSimpleEsp32.h>
#include <DHT.h>
#include <Servo.h>

// Authentication code for Blynk Application.

char auth[] = "d7c79ed00e8f4e9d9fe0c59c5aee631e";


//  WiFi data.
// Setting the password "" for open networks.
char ssid[] = "RBY"; // network name
char pass[] = ""; // network password

#define DHTPIN 17     // Temperature sensor pin connection 

// Type of dht sensor used in this project!
//#define DHTTYPE DHT11     // DHT 11
#define DHTTYPE DHT22   // DHT 22

//SERVOMOTOR
Servo servoGarage;//NAME OF THE SERVOMOTOR VARIABLE

//SERVO
BLYNK_WRITE(V3)// Sending data to virtual pin V3 from the application 
{
   servoGarage.write(param.asInt());// sending data as integers to Blynk app
}

// DHT
DHT dht(DHTPIN, DHTTYPE);
BlynkTimer timer;// Creation of a timer object BlynkTimer called timer

void sendSensor()
{
  float h = dht.readHumidity(); // Store the humidity value in h variable 
  float t = dht.readTemperature(); // Store the temperature value in t variable

  if (isnan(h) || isnan(t)) { // this will check to see if the sensor is working
    Serial.println("Erorr reading from DHT sensor!");
    return;
  }
  
  // Maximum of 10 values per second
  Blynk.virtualWrite(V2, h);
  Blynk.virtualWrite(V1, t);
}

void setup()
{
  // Debug console
  Serial.begin(9600);

  Blynk.begin(auth, ssid, pass);
  // The server can be specified:
  //Blynk.begin(auth, ssid, pass, "blynk-cloud.com", 8442);
  //Blynk.begin(auth, ssid, pass, IPAddress(192,168,1,100), 8442);

  dht.begin();
 
  
  // function that will be called every 1 second
  timer.setInterval(1000L, sendSensor); // this function will send data to Blynk app every 1 second
  
// GARAGE
  servoGarage.attach(18); // Servomotor connection pin
  
 //FAN
  pinMode(19,OUTPUT);//FAN CONNECTION PIN 
}
//FAN            
BLYNK_WRITE(V4){
  int buttonState = param.asInt();// sending data to the app as integers to read the state of the virtual button  
  digitalWrite(19,buttonState); // turn the fan on or off (buttonState = HIGH or LOW).
}

void loop()
{
  Blynk.run();// this will run Blynk function
  timer.run();//this will initialize the Blynk timer and it will run every 1 second 
}

