 //BOARD: Adafruit ESP 32 Feather

#include <WiFi.h>

// Replace with your network credentials

const char* ssid = "RBY";
const char* password = "";
 
WiFiServer server(80);
 
const int relA =  13;      // the number of the relay A pin ARDUINO MEGA 
 
const int relB =  14;      // the number of the relay B pin ESP 32 THING PLUS

 
// Client variables 
char linebuf[80];
int charcount=0;
 
void setup() 
{
  // initialize the relay A and B as an output
  pinMode(relA, OUTPUT);
  pinMode(relB, OUTPUT);
  //Initialize serial and wait for port to open
  Serial.begin(115200);
  while(!Serial) {
  }
   
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
   
  WiFi.begin(ssid, password);
   
  // attempt to connect to Wifi network:
  while(WiFi.status() != WL_CONNECTED) 
  {
    // Connect to WPA/WPA2 network.
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP()); 
  server.begin();
}
 
void loop() 
{
  // listen for incoming clients
  WiFiClient client = server.available();
  if (client) 
  {
    Serial.println("New client");
    memset(linebuf,0,sizeof(linebuf));
    charcount=0;
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) 
    {
      if (client.available()) 
      {
        char c = client.read();
        Serial.write(c);
        //read char by char HTTP request
        linebuf[charcount]=c;
        if (charcount<sizeof(linebuf)-1) charcount++;
 
        if (c == '\n' && currentLineIsBlank) 
        {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
          client.println();
          client.println("<!DOCTYPE HTML><html><head>");
          client.println("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\"></head>");
          client.println("<h1>ESP32 - Web Server example</h1>");
          client.println("<p>RELAY A <a href=\"onA\"><button>ONA</button></a>&nbsp;<a href=\"offA\"><button>OFFA</button></a></p>");
          client.println("<p>RELAY B <a href=\"onB\"><button>ONB</button></a>&nbsp;<a href=\"offB\"><button>OFFB</button></a></p>");
          client.println("</html>");
          break;
        }
        if (c == '\n') 
        {
          // you're starting a new line
          currentLineIsBlank = true;
          if (strstr(linebuf,"GET /onA") > 0)
          {
            Serial.println("RELAY A ON");
            digitalWrite(relA, HIGH);
          }
          else if (strstr(linebuf,"GET /offA") > 0)
          {
            Serial.println("RELAY A OFF");
            digitalWrite(relA, LOW);
          };
           if (strstr(linebuf,"GET /onB") > 0)
          {
            Serial.println("RELAY B ON");
            digitalWrite(relB, HIGH);
          }
          else if (strstr(linebuf,"GET /offB") > 0)
          {
            Serial.println("RELAY B OFF");
            digitalWrite(relB, LOW);
          }
 
          // you're starting a new line
          currentLineIsBlank = true;
          memset(linebuf,0,sizeof(linebuf));
          charcount=0;
        } 
        else if (c != '\r') 
        {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
 
    // close the connection:
    client.stop();
    Serial.println("client disconnected");
  }
}
